class giant
 {
 	private:
 	 enum { N_BU=4 };
 	 enum { _COL=25, _ROW=3, _XPIX=46, _YPIX=46 };
 	 int max_x,min_x,start_x,start_y,pos_x,pos_y,scroll_x,scroll_y,jump_y,_X,_Y,_i;
 	 int plat_y,plat_stair,plat_wall;
 	 int *ctrl_x,*ctrl_y;
 	 int energy;
 	 int dx,dy;
 	 int act_frame;
 	 bool can_hit,hittable;
 	 bool near,side,direction; // posizione speculare e direzione di moto 0 = destra, 1 = sinistra
 	 bool active,stop,move,fire,open,hitted,first_hit,dead,explode;
 	 timer *ti[5];
 	 bullet *BU[N_BU];
 	 SAMPLE *sound[4];
 	 BITMAP *frame[_COL*_ROW];
 	 BITMAP *frame_col[_COL*_ROW];
 	 BITMAP *out;
 	 map *plat_map;
 	 map *hight_map;
 	 map *back_map;

 	 void loadSpriteFrames(char *);
 	 void assignSpriteFrame(giant *);
 	 void setOutBitmap(BITMAP *);
 	 void shootBullet();
 	
 	public:
 	 giant(char *,int,int,BITMAP *,int i=0,giant *p=NULL);
 	 ~giant();
 	 void setStartX(int);
 	 void setStartY(int);
 	 void setMaxX(int);
 	 void setMinX(int);
 	 bool isActive();
 	 void drawSprite(int,int);
 	 void timeSprite();
 	 void platformSprite();
 	 void animSprite();
 	 void setPlatformMap(map *p);
 	 void setHightMap(map *p);
 	 void setBackgroundMap(map *p);
 	 void loadSample(char *,int);
 	 void assignSample(int,giant *);
 	 BITMAP *getActFrameColP();
 	 bullet *getBullet(int);
 	 bool inScreen();
   void setHitted(bool b);
   bool canHit();
   bool isHittable();
 	 int getPlatYPos();
 	 int getPosX();
 	 int getPosY();
 	 int getNBullet();
 	 void setCtrlXP(int *);
   void setCtrlYP(int *);
 	 int *getPosXP();
 	 int *getPosYP();
 	 int getScore();
 	 void resetObj(bool);
 	 void debug();
 };

giant::giant(char *filename, int sx, int sy, BITMAP *out, int i, giant *p)
 {
 	_i=i;
 	if(!_i) loadSpriteFrames(filename); else assignSpriteFrame(p);
 	setOutBitmap(out);
 	start_x=sx; start_y=sy;
 	min_x=0; max_x=0;
 	// Bullet (assegno i frame ai proiettili prendendoli dalla memoria gi allocata)
 	// Per adesso nessun "sound"  assegnato ai proiettili
 	//BU[0]->loadSample("data/sound/fx/hard.wav",0);  	
 	for(int i=0;i<N_BU;i++)
 	 {
 	 	BU[i]=new bullet("",out,1);
 	  //BU[i]->assignSample(0,BU[0]);
 	 	for(int j=0;j<_ROW*_COL;j++)
 	   {
 	    BU[i]->setFrameP(j,frame[j]);
 	    BU[i]->setFrameColP(j,frame_col[j]);
 	   }
 	 }
 	resetObj(true);
 	ti[0]=new timer(8);  // Anim time
 	ti[1]=new timer(2);  // Explode time
 	ti[2]=new timer(4);  // Hitted time (stop time)
 	ti[3]=new timer(random(100)+100); // Fire time
 	ti[4]=new timer(1);  // Move time
 }

giant::~giant()
 {
 	for(int i=0;i<N_BU;i++) delete(BU[i]);
 	for(int i=0;i<5;i++) delete(ti[i]);
 	if(_i==0)
 	 {
    for(int i=0;i<3;i++)    destroy_sample(sound[i]);
 	  for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame[i]);
 	  for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame_col[i]);
 	 }
 }

void giant::loadSpriteFrames(char *filename)
 {
 	BITMAP *aux;

  aux=load_bmp(filename,NULL);
  //for(int i=0;i<24;i++) frame[i]=create_sub_bitmap(aux,46*i+i,0,46,46);
  for(int i=0;i<_ROW;i++)
   for(int j=0;j<_COL;j++)
    {
     //frame[j+25*i]=create_sub_bitmap(aux,46*j+j,46*i+i,46,46);
     frame[j+_COL*i]=create_bitmap(_XPIX,_YPIX);
     blit(aux,frame[j+_COL*i],_XPIX*j+j,_YPIX*i+i,0,0,frame[j+_COL*i]->w,frame[j+_COL*i]->h);
     frame_col[j+_COL*i]=create_bitmap_ex(8,_XPIX,_YPIX);
     clear_to_color(frame_col[j+_COL*i],0);
     for(int h=0;h<frame[j+_COL*i]->h;h++)
      for(int w=0;w<frame[j+_COL*i]->w*4;w+=4)
       if(makecol32(frame[j+_COL*i]->line[h][w+2],
                    frame[j+_COL*i]->line[h][w+1],
                    frame[j+_COL*i]->line[h][w])!=16711935)
        frame_col[j+_COL*i]->line[h][w>>2]=1;
    }
  destroy_bitmap(aux);
 }

void giant::assignSpriteFrame(giant *p)
 {
 	for(int i=0;i<_ROW*_COL;i++)
 	 {
 	  frame[i]=p->frame[i];
 	  frame_col[i]=p->frame_col[i];
 	 }
 }

void giant::loadSample(char *filename, int n)
 {
 	sound[n]=load_sample(filename);
 }

void giant::assignSample(int n,giant *p)
 {
 	sound[n]=p->sound[n];
 }

void giant::setOutBitmap(BITMAP *bmp) { out=bmp; }

void giant::timeSprite()
 {
 	for(int i=0;i<5;i++) ti[i]->time();
 }

void giant::shootBullet()
 {
 	int n=-1;
 	
 	//play_sample(sound[0],120,150,1000,0);
 	for(int i=0;i<N_BU;i++) if(!BU[i]->isFired()) { n=i; break; }
 	if(n!=-1)
 	 {
 	 	if(fire)
 	 	 {
  	  BU[n]->shoot(pos_x,pos_y,*ctrl_x,*ctrl_y+7,side);
  	 }
   }
 }

void giant::animSprite()
 {
 	if(!active) return;
 	if(dead) return;
 	if(explode) 
 	 {
 	 	if(ti[1]->isOn()) act_frame++;
 	 	if(act_frame==12)
 	 	 {
 	 	  act_frame=0; dead=1;
 	 	  hitted=0;	   explode=0;
 	 	  move=0;      open=0;
 	 	  fire=0;
 	 	 }
 	 	return;
 	 }
 	near=pos_x>*ctrl_x-150 && pos_x<*ctrl_x+150 || first_hit;
 	if(ti[3]->isOn() && ((side==0 && *ctrl_x>pos_x) || (side==1 && *ctrl_x<pos_x))) { fire=1; move=0; open=1; ti[0]->reset(); act_frame=25; }
 	if(move)
 	 {
 	  if(side) dx=-1; else dx=1;
 	  if(ti[0]->isOn()) { act_frame++; }
 	  if(act_frame>4) act_frame=1;
 	  if(!near) { if(ti[4]->isOn()) pos_x+=dx; } else pos_x+=dx;
 	  if(_i==0) pos_y=plat_map->getActPlatformEnemies(pos_x,0);
 	 } 	    	
 	if(stop) { fire=0; open=0; dx=0; act_frame=5; move=0; if(ti[2]->isOn()) { stop=0; act_frame=1; open=0; move=1; } }
  if(open) { stop=0; if(ti[0]->isOn()) act_frame++; if(act_frame>26) { move=1; open=0; stop=0; act_frame=1; } } 	
  if(hitted) { play_sample(sound[0],120,150,1000,0); hitted=0; stop=1; act_frame=5; ti[2]->reset(); energy--; if(energy==0) { open=0; explode=1; move=0; act_frame=6; stop=0; play_sample(sound[1],120,150,1000,0); } else explode=0; ti[2]->reset(); return; }
  if(fire) { if(act_frame==26) { shootBullet(); fire=0; } }
 	if(!near)
 	 {
 	  if(pos_x<min_x) { side=0; } if(pos_x>max_x) { side=1; }
 	 	ti[0]->setTick(8);
   }
  else // giant near the player
   {
 	  if(*ctrl_x+48<pos_x && pos_x>min_x+100) side=1; if(*ctrl_x-48>pos_x && pos_x<max_x-100) side=0;
 	  if(pos_x<min_x) { side=0; } if(pos_x>max_x) { side=1; }
 	  ti[0]->setTick(4);
   }
 }

void giant::drawSprite(int sx,int sy)
 {
 	if(!active) return;
  //pivot_sprite(rend,car,rend_x,rend_y,piv_cx,piv_cy,itofix(ang1));
  _X=-sx+pos_x-23; _Y=-sy+pos_y-12;
  if((act_frame>0 && act_frame<6) || (act_frame>=25 && act_frame<27)) can_hit=true; else can_hit=false;
  if(act_frame<5 || (act_frame>=25 && act_frame<27)) hittable=true; else hittable=false;
  if(inScreen())
   {
   	if(act_frame==3) play_sample(sound[2],120,150,1000,0);
    if(side) draw_sprite_h_flip(out,frame[act_frame],_X,_Y);
    else     draw_sprite       (out,frame[act_frame],_X,_Y);
   }
  // Bullet
  for(int i=0;i<N_BU;i++)
   {
   	BU[i]->drawSprite(sx,sy);
    BU[i]->timeSprite();
 	  BU[i]->animSprite();
 	  //BU[i]->platformSprite();
    //BU[i]->drawSprite(plat_map->getScrollX());
   }
 }

void giant::platformSprite()
 {
 	if(_i!=0) return; // Solo il primo "giant" segue le piattaforme
 	if(!active) return;
 	if(explode || dead) return;
 	plat_wall=0;
 	if(!hitted && !explode)
 	 {
 	  if(pos_y>plat_y) if(pos_y-plat_y<=8) pos_y=plat_y; 
 	  if(pos_y<plat_y) if(plat_y-pos_y<=8) pos_y=plat_y; 
 	  //if(pos_y<plat_y) { fall=1; dy++; if(dy>6) dy=6; dx=0; } else { fall=0; dy=0; }
 	 }
 	plat_y=plat_map->getActPlatformEnemies(pos_x,pos_y);
 	//if(!unrise) plat_wall=plat_map->getActPlatformEnemies(pos_x,pos_y,2,direction);
 	plat_stair=0;//plat_map->getActStairEnemies(1);
 }

bullet *giant::getBullet(int n) { return BU[n]; }

BITMAP *giant::getActFrameColP() { return frame_col[act_frame]; }

bool giant::inScreen()
 {
 	if(_X>=-62 && _X<=384) return true;
 	else return false;
 }

int giant::getPlatYPos() { return plat_y; }

int giant::getPosX() { return _X; }

int giant::getPosY() { return _Y; }

int giant::getScore() { if(energy==1) return 400; else return 0; }

int giant::getNBullet() { return N_BU; }

void giant::setCtrlXP(int *p) { ctrl_x=p; }

void giant::setCtrlYP(int *p) { ctrl_y=p; }

int *giant::getPosXP() { return &pos_x; }

int *giant::getPosYP() { return &pos_y; }

void giant::setPlatformMap(map *p) { plat_map=p; }

void giant::setHightMap(map *p) { hight_map=p; }

void giant::setBackgroundMap(map *p) { back_map=p; }

void giant::setHitted(bool b) { hitted=b; first_hit=1; }

bool giant::canHit() { return can_hit; }

bool giant::isHittable() { return hittable; }

bool giant::isActive() { return active; }

void giant::setStartX(int sx) { start_x=sx; }

void giant::setStartY(int sy) { start_y=sy; }

void giant::setMaxX(int mx) { max_x=mx; }

void giant::setMinX(int mx) { min_x=mx; }

void giant::resetObj(bool act)
 {
 	active=act;
 	pos_x=start_x; pos_y=start_y; scroll_x=0; scroll_y=0; jump_y=0;
 	energy=16;
 	dx=0; dy=0; plat_y=start_y; near=false; first_hit=0;
 	act_frame=1;
 	stop=0; move=1; fire=0; open=0; hitted=0; dead=0; explode=0;
 	side=1; direction=0;
 	for(int i=0;i<N_BU;i++) BU[i]->resetObj();
 }

void giant::debug()
 {
 	putpixel(out,pos_x,pos_y-30+58,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+59,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+61,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+62,makecol32(255,0,0));
  putpixel(out,pos_x-2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x+2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x-1,pos_y-30+61,makecol32(255,0,0));
  putpixel(out,pos_x+1,pos_y-30+61,makecol32(255,0,0));
 }
